#include "Xbp.ch"
#include "Common.ch"
#include "Inkey.ch"
#include "directry.CH"
#include "xbtdisk.ch"
#pragma library( "XBTBASE1.LIB" )
#pragma library( "XBTBASE2.LIB" )

#ifndef CRLF
   #define CRLF chr(13)+chr(10)
#endif

* Dieses Programm soll viele Dateien suchen und den Dateinamen an eine andere funktion bergeben.
* Geschwindigkeitsvergleich zwischen FileFind() und DIR *.* /B ....

procedure main
   local nWahl

   set charset to ansi


   set alternate to TestDirRead.txt
   set alternate on

   ? "Start von TestDirRead",date(),time()
   ?
   ? "ExePath(): ", ExePath()
   ?

   cls

   @ 1,1 say "Dateinamen aus einem vollen Verzeichnis ermitteln"
   @ 3,1 say "Speedtest"
   @ 4,1 say "1 = FindFile() aus den Tools "
   @ 5,1 say "2 = DIR *.* /B > TempFile(), HBTextReader()  "
   @10,1 say "Andere Eingabe beendet das Programm: "

   @14,1 say "Testart:        " // 14,17 fr Anzeige
   @15,1 say "gefunden:       " // 15,17 fr Anzeige
   @16,1 say "aktuelle Datei: " // 16,17 fr Anzeige

   // Keines Falles alle Treffer anzeigen, sonst viel zu langsam, Schrittweite 1000 ok ?

   do while .t.
      @14,17 CLEAR TO 14,79
      @15,17 CLEAR TO 15,79
      @16,17 CLEAR TO 16,79
      @10,40 say " "
      nWahl := inkey(0)
      @20,0 CLEAR TO 20,79
      @17,0 say ""
      do case
         case nWahl == asc("1")
              TesteFindFile()
         case nWahl == asc("2")
              TesteDIR()
         otherwise
              exit
      end

      @20,10 say "Fertig"

   enddo

   ? "Programmende"
   set alternate to

return

*----------------------------------------------------------------
procedure MyAction(x,cFileName)
   static counter := 0
   local cDatenDir := ExePath()+"Daten\"
   // hier wird die Arbeit erledigt. Ich protokolliere nur.
   if x <= 1
      counter := 0
   endif
   if empty(counter)
      @16,17 CLEAR TO 16,79
      @15,18 say x picture "999,999,999,999"
      @16,17 say ConvToOEMCP(cFileName)+"  "+iif(FExists(cDatenDir+cFileName),"gefunden","fehlt")
      set console off
      ? "Datei:",x,cFileName,"gefunden ? ",FExists(cDatenDir+cFileName),"Time:",time()
      set console on
      counter := 999
   else
      counter--
   endif

   if inkey() = K_ESC
      ? "Abbruch"
      quit
   endif

//   sleep(0) // mit 0 bremst es etwas (etwa 50 %), mit 1 bremst es stark !!!

return

*----------------------------------------------------------------
function ExePath()
   local cDrive := CurDrive()
   local cPfad  := CurDir(cDrive)
return cDrive + ":\" + cPfad + "\"

*----------------------------------------------------------------
function DQ() // erleichtert das schreiben von CMD Commandos da Dateinamen in " eingefasst werden mssen
   local cReturn := '"'
return cReturn

*----------------------------------------------------------------
procedure TesteFindFile()
   local nDauer, cFile, nFile, cSuchString

   @14,17 say "TesteFindFile()"
   set console off
   ?
   ? "Aktion: TesteFindFile()"
   ?

   nDauer := seconds()

   set console on

   cSuchString := ExePath()+"Daten\*.*"

   cFile := FileSeek( cSuchString ) // kann auch Verzeichnisse enthalten !!!
   nFile := 0

   set console off
   ? "Erste Datei gefunden ?", cFile, FileAttr( ExePath()+"Daten\"+cFile )
   set console on

   do while ! empty(cFile)

      if FileAttr( ExePath()+"Daten\"+cFile ) = FA_DIRECTORY
         // Verzeichnisse ignorieren !
         set console off
         ? "Verzeichnis:", cFile, "Verzeichnis ignorieren ! FA:", FileAttr( ExePath()+"Daten\"+cFile )
         set console on
      else

         nFile++

         MyAction( nFile, cFile )

      endif

      cFile := FileSeek()

   enddo

   nDauer := seconds() - nDauer

   set console off

   ? "Ende des Durchlaufes, Dauer:",nDauer,"Sekunden, oder ",nDauer/60,"Minuten, oder ",nDauer/3660,"Stunden"

   set console on

return

*----------------------------------------------------------------
procedure TesteDIR()
   local nDauer, cTempFile, oTR, cCMD
   local nFile, cFile


   @14,17 say "TesteDIR()"
   set console off
   ?
   ? "Aktion: TesteDIR()", date(), time()
   ?

   nDauer := seconds()

   cTempFile := ExePath()+"TMP"+alltrim(str(seconds(),12,0))+".txt"

   ? "Temporre Datei erstellen: ", cTempFile
   ? "Start: ",date(),time()

   cCMD := "/C DIR "+DQ()+ExePath()+"Daten\*.*"+DQ()+" /B > "+DQ()+cTempFile+DQ()

   ? "RunShell() mit DIR /B:     ",;             // Rckgabewert anzeigen
     RunShell( cCMD ) // Eventuelle Blanks bercksichtigen
   ? "Ende:  ",date(),time(),"Lnge der Datei:", filesize(cTempFile)
   ? "Dauer fr DIR /B :", seconds() - nDauer , "Sekunden"

   oTR := HBTextReader( cTempFile ) // per Funktion

   if oTR:FError() <> 0
      @20,1 say "Fehler beim Datei ffnen: "+oTR:ErrMsg()
      ? "Fehler beim Datei ffnen: "+oTR:ErrMsg()
      inkey(30)
      quit
   endif

   do while ! oTR:EOF()

      cFile := oTR:GetLine() // zuerst den Dateinamen holen, intern wird auf nchste Zeile gesetzt
      nFile := oTR:RecNo()   // dann stimmt die RecNo dieses Namens

      // Wie sich herausstellte sind die Dateinamen in der temporren Datei in OEM !!!
      // Dateifunktionen sind meist aber ANSI ... besser Umlaute vermeiden ;-)

      cFile := ConvToAnsiCP( cFile )

      MyAction( nFile, cFile )

   enddo

   oTR:Destroy()
   delete file (cTempFile)

   nDauer := seconds() - nDauer

   set console off

   ? "Ende des Durchlaufes, Dauer:",nDauer,"Sekunden, oder ",nDauer/60,"Minuten, oder ",nDauer/3660,"Stunden"

   set console on

return

* Klasse zum sequentiellen Einlesen groer Dateien
* Da die Blockgre auf 4 KB begrenzt ist, kann man auch einfach die Zeilen ausschneiden.

#include "Fileio.ch"

function HBTextReader( cFile )
   local oTR := HBTxtReader():new( cFile )
return oTR

CLASS HBTxtReader
  PROTECTED:
     VAR nH
     VAR nLastError
     VAR IsEOF           // Buffer hat beim Einlesen EOF erreicht, Zeilen knnen noch da sein !
     VAR cRest
     VAR nBufferBytes    // Anzahl der gelesenen Byte im Buffer
     VAR cCRLF, nLenCRLF // Unix/Linux nur chr(10) = 1 Byte, Windows chr(13)+chr(10) = 2 Byte
     VAR Line
     METHOD ReadBuffer

  EXPORTED:
     METHOD Init
     METHOD Destroy
     METHOD GetLine
     METHOD GoTop
     METHOD FSize
     METHOD FError
     METHOD ErrMsg
     METHOD EOF
     METHOD IsCrLf
     METHOD IsUnix
     METHOD IsMac
     INLINE METHOD RecNo    ; RETURN ::line
     INLINE METHOD LenCrLf  ; RETURN ::nLenCRLF
     METHOD FileType

ENDCLASS

METHOD HBTxtReader:Init( cFileName )       // ffnet die Datei zum Lesen
   ::nLastError   := 0
   ::cRest        := ""
   ::nBufferBytes := 0
   ::Line         := 0
   ::nH    := fopen( cFileName , FO_READ + FO_SHARED )
   if ::nH = -1
      ::nLastError := FError()
      ::IsEOF      := .t.
   else
      ::IsEOF      := .f.
      ::ReadBuffer()
      do case
         case chr(13)+chr(10) $ ::cRest // Windows etc.
              ::cCRLF    := chr(13)+chr(10)
              ::nLenCRLF := 2
         case chr(10)         $ ::cRest // Unix
              ::cCRLF    := chr(10)
              ::nLenCRLF := 1
         case chr(13)         $ ::cRest // Mac
              ::cCRLF    := chr(13)
              ::nLenCRLF := 1
      end
   endif
RETURN SELF

METHOD HBTxtReader:Destroy()
   if ::nH <> -1
      FClose(::nH)
      ::nH := -1
   endif
   ::cRest := ""
RETURN SELF

METHOD HBTxtReader:ReadBuffer()
   local cBuffer, nBufferLen, nBytes
   if ::nH > -1
      nBufferLen := 4096
      cBuffer    := space(nBufferLen)
      nBytes     := FRead( ::nH, @cBuffer, nBufferLen)
      cBuffer    := StrTran(cBuffer,chr(26)," ")
      ::nBufferBytes += nBytes
      if nBufferLen = nBytes // mitten in Datei
         ::cRest += cBuffer
      else
         ::cRest += left(cBuffer,nBytes)
         ::IsEOF := .t.
         if FError() <> 0
            ::nLastError := FError()
         endif
      endif
      cBuffer := ""
   endif
Return

METHOD HBTxtReader:GetLine()
   local nPosCRLF
   local cLine := ""
   do while ! ::cCRLF $ ::cRest .and. ! ::IsEof  // Buffer einlesen, bis wir neue Zeilen haben oder die Datei gelesen wurde
      ::ReadBuffer()
   enddo
   nPosCRLF := at( ::cCRLF, ::cRest)
   if nPosCRLF > 0 // es gibt noch eine komplette Zeile, zurckgeben und krzen
      cLine   := left(::cRest,nPosCRLF-1)
      ::cRest := substr(::cRest,nPosCRLF+::nLenCRLF)
   else
      cLine   := ::cRest
      ::cRest := ""
   endif
   ::Line++
return cLine

METHOD HBTxtReader:GoTop()
   if ::nH <> -1
      FSeek(::nH, 0 , FS_SET )
   endif
   ::cRest   := ""  // zwingt zum neu einlesen
   ::Line    := 0
   ::ReadBuffer()
return NIL

METHOD HBTxtReader:FSize()
   local nSize := 0
   if ::nH <> -1
      nSize := FSize(::nH)
   endif
RETURN nSize

METHOD HBTxtReader:FError()
RETURN ::nLastError

METHOD HBTxtReader:EOF()
RETURN ::IsEOF .and. empty(::cRest)

METHOD HBTxtReader:IsCrLf()
RETURN (::cCRLF == chr(13)+chr(10))

METHOD HBTxtReader:IsUnix()
RETURN (::cCRLF == chr(10))

METHOD HBTxtReader:IsMac()
RETURN (::cCRLF == chr(13))

METHOD HBTxtReader:ErrMsg()
RETURN DosErrorMessage(::nLastError)

METHOD HBTxtReader:FileType()
   local cTxt := ""
   do case
      case ::IsCrLf()
           cTxt := "CRLF"
      case ::IsUnix()
           cTxt := "UNIX/Linux"
      case ::IsMac()
           cTxt := "MAC"
   end
return cTxt
